Skip to content

Enable Dual-classing into Kits (now with Proficiency Fix)

kjeronkjeron Member Posts: 2,356
edited April 28 in UI Modding
Dual-class into Kit

Installation Order:
* This mod should NOT be installed BEFORE any mod that adds new kits.
* This mod should NOT be installed BEFORE any mod that alters race (MGSRCREQ.2da/CLSRCREQ.2da) or dualclass (DUALCLAS.2da/ABDCDSRQ.2da) restrictions.
* This mod should NOT be installed BEFORE any mod that alters string references in CLASTEXT.2da, KITLIST.2da, or RACETEXT.2da/SODRACE.2da.
* This mod should NOT be installed BEFORE any mod that alters alignment (ALIGNMNT.2da) restrictions.
* The third component(proficiency) should also NOT be installed BEFORE any mod that alters or reads (WEAPPROF.2da).

Limitations(primary component):
* Class/Kit description in the record screen will display the description of the unkitted second class.
* Specialists Mages will not recieve their bonus spell slots. (Fix included in second component.)
* Level-up proficiency selection is still dictated as if an unkitted second class. (Potential fix included in thrid component.)
(These are all the same issues that occur when you manually change the second-class kit through EEkeeper/Near Infinity)
* (NEW) If installed, Kit-to-Kit dual-classing will replace your current kit with the new one. Abilities gained through the old kit's CLAB will be retained, but any aspects that come from 2da-files or are hardcoded will be lost, nor will the old kit be detectable by scripts or dialog.

Limitations(proficiency component)
* This component is still experimental, I would urge you to save being clicking "Level-up".

* All (kit or not) dual-classed character's proficiency options will be strictly enforced. Reactivating their original class will not expand their proficiency limitations, they still regain any proficiency that had from that class, they just cannot add to them beyond what their second class normally allows.
* Level requirements for proficiency will continue to follow PROFSMAX.2da.
* Mods that replace a Base class with a kit, should utilize the mods base-class kit proficiency options for the unkitted class, provided the kit and class share the same name. Any character with the base-class kit will use that kits proficiency options as expected.
* Mods that add a Multi-class kit and Single-class kit under the same name will attempt to differientiate them by their kit description. If it fails they might end up using the others proficiency options.
* If it fails to identify class/kit, it should default to FIGHTER or NONE proficiency options, to avoid being stuck during level. This should only happen if their current kit(or trueclass) has been disabled / made invalid by other mods.
* Original WEAPPROF.2da values will be copied to WEAPPROF_backup.2da for reference.


Compatibility:
* v2.3+: BGEE, BGSOD, BG2EE
* v2.5+: IWDEE
* Should work for any language. Only installation prompts are in English.
* Supports multiple campaign files, as read from CAMPAIGN.2da.
* UI edits have been reworked, should be more compatible with other UI mods.



Post edited by kjeron on
StummvonBordwehrNoobaccaRedrakeGrammarsaladIllustairAndreaColomboJuliusBorisovWarChiefZekeSequiterAbelMirandelRaduzielelminsterRAM021GusindaContemplative_Hamstermashedtatersbob_vengCrevsDaak
«1345

Comments

  • chimericchimeric Member Posts: 1,163
    It's pleasant to realize that I think I understand how you've done this.
    WarChiefZekeRAM021
  • The user and all related content has been deleted.
  • WarChiefZekeWarChiefZeke Member Posts: 2,646
    Highly approve of this mod, opens up a number of RP options and is far more convienient than EEKeepering, especially when it comes to companions.

    We all know Shar Teel is meant to be an assassin. ;)
    GrammarsaladRaduzielmashedtaters
  • SequiterSequiter Member Posts: 2
    Drat, it doesn't work for me. I'm running BGEE with SoD, currently playing SoD.

    I moved the setup-DUAL_TO_KIT.exe and DUAL_TO_KIT folder to my game directory and ran the exe, choosing to install both components. I ran the game, and tried to dual-class my Kensai, but only got regular Mage and Thief options.

    The only other mod I'm running is the Gibberlings Tweaks Anthology, which I installed first. My game is up to date, and I've run modmerge.

    Any insight as to what might be the problem?
  • SequiterSequiter Member Posts: 2
    Annnd I just tried it in a clean install of BG2EE - didn't work at all.
  • kjeronkjeron Member Posts: 2,356
    edited December 2017
    @Sequiter I'll look into it, I've just been without Internet all last week.

    Edit - This is working as intended. This mod only opens up options allowed by the original BG1 engine (dualing an unkitted character into a kit for their second class), it does not allow creating characters with multiple kits. This is a limitations of the engine, as creatures can only possess a single kit.
    Post edited by kjeron on
    bob_vengelminsterRAM021
  • RAM021RAM021 Member Posts: 403
    Following for updates - thanks!
  • kjeronkjeron Member Posts: 2,356
    Fixed case-sensitive kitname matching issue.
    Raduzielmashedtaters
  • RaduzielRaduziel Member Posts: 4,714
    Thanks for that :)
  • The user and all related content has been deleted.
    tbone1
  • Necromanx2Necromanx2 Member Posts: 1,237
    I started a new game in BG2EE with a fighter. I immediately dualed over to an invoker. I do not received the bonus spell slot. I then have Imoen disarm the trap, pick lock, and then rescue Minsc and go up a level. Again, no bonus spell slot added.
  • kjeronkjeron Member Posts: 2,356

    I started a new game in BG2EE with a fighter. I immediately dualed over to an invoker. I do not received the bonus spell slot. I then have Imoen disarm the trap, pick lock, and then rescue Minsc and go up a level. Again, no bonus spell slot added.

    I found the problem, Cleric and Fighter duals require a different approach than the Thief duals, because internally they become a Fighter/Mage or Cleric/Mage, while the other is a Mage/Thief - i.e. order matters.

    It should work now, but it can only occur when you dual-class, it will not kick-in at later level-ups if you have already dualclassed. I haven't found any way to accurately detect the differences between a single-class and a still-inactive dual-class beyond the first level, as both register as a single class mage.
    GusindaContemplative_HamstermashedtatersRAM021
  • Necromanx2Necromanx2 Member Posts: 1,237
    Thanks @kjeron! It works now.
    tbone1
  • Contemplative_HamsterContemplative_Hamster Member Posts: 844
    Lovely! This solves a LOT of HR management issues I have regarding party composition for my next run
    mashedtaters
  • Necromanx2Necromanx2 Member Posts: 1,237
    @kjeron, when you start as a mage (non-specialist) and then dual to a kit for a fighter, cleric, or thief, the mage gets bonus spells as if he were a specialist once the second class overtakes the first in levels. Is it possible to add something that imposes a -1 spell slot per spell level when your dual started as a mage? It is fine if it is imposed at dualing since it won't take effect until the second class overtakes the first.
  • kjeronkjeron Member Posts: 2,356
    edited March 2018

    @kjeron, when you start as a mage (non-specialist) and then dual to a kit for a fighter, cleric, or thief, the mage gets bonus spells as if he were a specialist once the second class overtakes the first in levels. Is it possible to add something that imposes a -1 spell slot per spell level when your dual started as a mage? It is fine if it is imposed at dualing since it won't take effect until the second class overtakes the first.

    Lol, that should be easy to fix, pretty sure the Wildmage is what's causing this (as it shares CLAB with the unkitted mage).

    Edit: Nevermind, those are 2 different issues, well the potential issue from the Wildmage is fixed, I'll look into the other (which also happens to be complicated by the Wildmage).
    mashedtaters
  • kjeronkjeron Member Posts: 2,356
    @Necromanx2 It doesn't look good. The extra slot is applied to multiclasses(any kit) and when dualing mage->kit, but not when dualing kit->mage. I'm not sure how to apply something that would work correctly for all 3 situations.
    mashedtaters
  • Necromanx2Necromanx2 Member Posts: 1,237
    OK. Is there an EEKeeper setting I can set to add the -1 spell per level? Then I can manually add it when I do dual (or multi-class) that is impacted.
  • kjeronkjeron Member Posts: 2,356
    edited March 2018
    EEKeeper can add an effect to the character:
    Opcode (Type) = 42
    Target = 1 (Self)
    Parameter1 (Slot Amount Modifier)= (-1)
    Parameter2 (Spell Level) = 511 (all levels = 1 + 2 + 4 + 8 + 16 + 32 + 64 + 128 + 256)
    Timing (Flags) = 9 (Instant, Permanent)
    Other = default
    mashedtaters
  • Necromanx2Necromanx2 Member Posts: 1,237
    Thank you!
  • [Deleted User][Deleted User] Posts: 0
    edited March 2018
    The user and all related content has been deleted.
  • kjeronkjeron Member Posts: 2,356
    edited May 2018
    Update(v.14)
    - Kit's will now only be displayed if they are allowed to dual into the original class, as listed in DUALCLAS.2da.
    - Graphics fixed for BGEE/BG2EE, should now display the proper background while selecting a class/kit.

    Edit - Done button doesn't light up in BGEE/BG2EE, but is clickable when appropriate. WIP.
    GusindamashedtatersRAM021
  • kjeronkjeron Member Posts: 2,356
    Update(v.16)
    - Added support for IWDEE (v2.5+)
    - Added experimental component for proficiency selection (specifics in first post).
    Raduziel
  • RaduzielRaduziel Member Posts: 4,714
    I'm having an install error
    32
    Copying and patching 1 file ...
    [./override/SODCLTXT.2DA] loaded, 23475 bytes
    ERROR: cannot convert FALLEN or %FALLEN% to an integer
    ERROR: [SODCLTXT.2DA] -> [override] Patching Failed (COPY) (Not_found)
    Stopping installation because of error.
    ERROR: [CAMPAIGN.2DA] -> [override] Patching Failed (COPY) (Not_found)
    Stopping installation because of error.

    ERROR Installing [Enable Dualclassing into Kits], rolling back to previous state
    Unable to Unlink [DUAL_TO_KIT/0/OTHER.0]: Unix.Unix_error(1, "unlink", "DUAL_TO_KIT/0/OTHER.0")
    [DUAL_TO_KIT/0/UNSETSTR.0] SET_STRING uninstall info not found
    Will uninstall 1 files for [DUAL_TO_KIT/SETUP-DUAL_TO_KIT.TP2] component 0.
    Uninstalled 1 files for [DUAL_TO_KIT/SETUP-DUAL_TO_KIT.TP2] component 0.
    Unable to Unlink [DUAL_TO_KIT/0/READLN.0]: Unix.Unix_error(20, "unlink", "DUAL_TO_KIT/0/READLN.0")
    Unable to Unlink [DUAL_TO_KIT/0/READLN.0.TEXT]: Unix.Unix_error(20, "unlink", "DUAL_TO_KIT/0/READLN.0.TEXT")
    The only other mod installed is DoF.
  • kjeronkjeron Member Posts: 2,356
    Oops, try again (v.16a).
  • RaduzielRaduziel Member Posts: 4,714
    edited June 2018
    It installs and works like a charm with DoF restrictions.

    Edit: It even fixes the issue I was having with Anomen's proficiencies. Damn good.
  • Necromanx2Necromanx2 Member Posts: 1,237
    @kjeron, I installed v.16a and tried to start a new character in BG2EE. I attempted a Priest of Myrkul (using @raduziel DoF). I cannot select any weapon proficiencies as none show in the list (3 pips with nothing to select). I uninstalled just the second class honors proficiency component (kept dual to kit and given specialist wizards extra spell slot) and it works fine.

    Also, it does not see a Shadow Adept (Artemius_I mod) as a specialist wizard as I don't get the extra spell per level of specialist.
    Raduzielglobocide
  • kjeronkjeron Member Posts: 2,356

    @kjeron, I installed v.16a and tried to start a new character in BG2EE. I attempted a Priest of Myrkul (using @raduziel DoF). I cannot select any weapon proficiencies as none show in the list (3 pips with nothing to select). I uninstalled just the second class honors proficiency component (kept dual to kit and given specialist wizards extra spell slot) and it works fine.

    Also, it does not see a Shadow Adept (Artemius_I mod) as a specialist wizard as I don't get the extra spell per level of specialist.

    I'll need more information on Myrkul:
    - Latest DoF version does not allow installing Myrkul on BG2EE (IWDEE only).
    - Even after overriding this, I still cannot reproduce the issue in BG2EE.

    Specialist issue was a simply looping error, and has been fixed(v.17).
Sign In or Register to comment.